<pre><?
/**
 * @package FTP Min
 * @author Akash Heimlich
 * @description Runs once a minute
 */
function is_ok($str) {
    $res=1;
    for ($x=0;$x<strlen($str);$x++) {
        $o=charat($str,$x);
        if ((($o >= 65) && ($o < 91)) || (($o >= 97) && ($o <= 122)) || (($o >= 48) && ($o <=57 )) || ($o==32) || (($o>=44)  && ($o<=46))) {
            $ok=1;
        } else {
            $res=0;
        }
    }
    return $res;
}
    $_GLOBALS['ftp_counter']++;

    $y=strftime("%y",time());
    $y2=strftime("%Y",time());
    $day=strftime("%d",time());
    $m=strftime("%m",time());
    $base_dir="/logs/";
    $fs_prefix='';
    // if data logging is necessary
    //$_GLOBALS['ftp_interval']=1;
    $min=intval(strftime("%M",time()));
    
    $ftp_enabled = ini_get("/config/ftp.ini","config","ftp_enabled",1);
    
    if ($ftp_enabled) {
    
    $last_export_time=ini_get($fs_prefix."/config/ftp_status.ini","status","last_export",0);
    $last_export_file=ini_get($fs_prefix."/config/ftp_status.ini","status","file","");
        
    $last_export_filepos=ini_get($fs_prefix."/config/ftp_status.ini","status","filepos",0);
        
	print("last export time=".$last_export_time."\r\n");
	print("last export file=".$last_export_file."\r\n");
	print("last export pos=".$last_export_filepos."\r\n");
	
    $logdir=$fs_prefix."/logs/"+strftime("%Y",time())."/".strftime("%m",time())."/";

// month change bug
	    // if this is new, just start from now
    if (!$last_export_file) {
            $last_export_time=time();
            $m=strftime("%M",time());
            $h=strftime("%H",time());
            $last_export_file = strftime("%Y%m%d",time())."_0.csv";
            $last_export_filepos=filesize($logdir.$last_export_file);
            print("updating ini file");
            ini_set($prefix."/config/ftp_status.ini","status","filepos",$last_export_filepos);
            ini_set($prefix."/config/ftp_status.ini","status","last_export",time());
            ini_set($prefix."/config/ftp_status.ini","status","file",$last_export_file);
            	                    
    } else {
			$y=substr($last_export_file,0,4);
			$m=substr($last_export_file,4,2);
			$cury=strftime("%Y",time());
			if ($y<$cury-1) {
				print("Year wrong, resetting log file (cury=".$cur." and year=".$y);
				unlink($fs_prefix."/config/ftp_status.ini");
				return;
			}
           
            $logdir=$fs_prefix."/logs/"+$y."/".$m."/";
    }
        
    $last_size=filesize($logdir.$last_export_file);
    
    if ($last_size<=$last_export_filepos+2) {  // added 2 bytes if the last line is CR+LF

			$y=substr($last_export_file,0,4);
			$m=substr($last_export_file,4,2);
			$d=substr($last_export_file,6,2);
			print("fn=".$y." ".$m." ".$d."\r\n");
			$t=mktime(0,0,0,intval($m)-1,intval($d),intval($y))+86400;

            $m=strftime("%m",$t);
            $d=strftime("%d",$t);
			$y=strftime("%Y",$t);
			$logdir=$prefix."/logs/"+$y."/".$m."/";
	        $new_export_file = strftime("%Y%m%d",$t)."_0.csv";
			
	        print($t." ".$logdir);
            
            print("Check for new file ".$new_export_file);
			if (!file_exists($logdir.$new_export_file)) {
    			    if (($t<(time()-86400*30)) || ($t>time())) {
        		        $logdir=$fs_prefix."/logs/"+strftime("%Y",time())."/".strftime("%m",time())."/";
                    	$new_export_file = strftime("%Y%m%d",time())."_0.csv";
        		        // if we have switched days
        		        if ($new_export_file!=$last_export_file) {
        		            if ((time()-$last_export_time)>(intval($ini['intervalportal'])*6)) {
        		                $last_export_file=$new_export_file;
        		                $last_export_filepos=0;
        		                
        		            }
        		        }
			    }
			} else {
                $last_export_file=$new_export_file;
                $last_export_filepos=0;
			}
    }
        
        // if for any reason the log file does not exist, just move to today's file at the current position.
    if (file_exists($logdir . $last_export_file)) { // && ($min %5==0)) {
            
        $fsize=filesize($logdir . $last_export_file);
        $has_data=0;
        if ($last_export_filepos < $fsize) {
            print("last_log_pos=".$last_export_filepos." and filesize=".$fsize."\r\n");
            
            $local_log_file=$last_log_file;
            $has_data=1;
        } 
		
        if ($has_data) {
            $cur_line=0;
            $log_st='';
            log("[ftp] push data trial ".ftp_is_busy());
            $host = ini_get("/config/ftp.ini","config","ftp_url","");
            $user = ini_get("/config/ftp.ini","config","ftp_username","");
            $pass = ini_get("/config/ftp.ini","config","ftp_password","");
            $ftp_secure = ini_get("/config/ftp.ini","config","ftp_secure",0);
            $ftp_ignore_response = ini_get("/config/ftp.ini","config","ftp_ignore_response",0);
            $folder_path=ini_get("/config/ftp.ini","config","ftp_path","/");
            $multiple_files = ini_get("/config/ftp.ini","config","multiple_files",1);
            $prefix = ini_get("/config/ftp.ini","config","ftp_prefix","");
            $port=21;
            max_execution_time(60);
            
            if (ftp_is_busy()) {
                $stat=ftp_status();
                if ($stat['status']==-1) $_GLOBALS['ftp_busy']=5; 
                $_GLOBALS['ftp_busy']++;
                log("FTP is busy...");
                print("FTP is busy...");
                if ($_GLOBALS['ftp_busy']>5) {
                    log("Force close FTP..");
                    ftp_close();
                } else {
                    //die();
                }
            } else {
                $_GLOBALS['ftp_busy']=0;
                $ftp = ftp_open($host,$port,$user,$pass,$ftp_secure,1,$ftp_ignore_response);
                if (!$ftp) {
                    log("ERROR ESTABLISHING");
                    print("ERROR ESTABLISHING");
                    if (!ftp_is_busy()) {
                        ftp_close();
                    }
                    return;
                }
                while (!ftp_is_connected()) {
                    if (ftp_error()>0) {
                        print("FTP ERROR "+ftp_error());
                         ftp_close();
                        return;
                    }
                }
                
                
    //            $res=ftp_command("mkd ".$folder_path); // make the folder
    //            $res=ftp_command("mkd ".$folder_path.$dev['name']); // make the folder
                
                $res=ftp_command("cwd ".$folder_path);
                print("cwd result=".$res);
                
                // standard upload method - just sync
                if (!$multiple_files) {
                    $size=ftp_size($last_export_file);
                    print("File size=".$size);
    //                die();
                    if ($size!=filesize($logdir.$last_export_file)) {
                        print("File size is ".$size."\r\n");
                        if ($size<0) $size=0;
                        $res=ftp_upload($last_export_file,$logdir.$last_export_file,$size,1);
                        print ("upload result is ".$res);
                        if ($res==1) {
                            
                            ini_set("/config/ftp_status.ini","status","filepos",filesize($logdir.$last_export_file));
                            ini_set("/config/ftp_status.ini","status","file",$last_export_file);
        
                        } else {  // deal with dongle reconnection issue
                            $stat=get3gstat(); 
                            if ($stat['enabled']) {
                                if ($stat['connected']) {
                                    if ($stat['ip_address']!='0.0.0.0') {
                                        $_GLOBALS['error3g']++;
                                        if ($_GLOBALS['error3g']>=5) {
                                            log("Cellular link seems to have died, restarting USB power");
                                            setusbpower(0);
                                            sleep(100);
                                            setusbpower(1);
                                            $_GLOBALS['error3g']=0;
                                        }
                                            
                                    }
                                }
                            }
                        }
                    } else {
                        print("Nothing to do.  Remote File size is ".$size);
                        ini_set("/config/ftp_status.ini","status","filepos",$size);
                        ini_set("/config/ftp_status.ini","status","file",$last_export_file);
                    }
                } else {
                    if (!file_exists('/logs/ftp_temp.csv')) {
                        print('/logs/ftp_temp.csv does not exist, creating it..\r\n');
                        $f_log=fopen($logdir.$last_export_file,"r");
                        $lines=array();
                        $export_size=0;
                        $csv_size=0;
                        $mem_lines=0;
        
                        if ($f_log) {
                            // navigate to the last saved pos
                            print("Seeking to ".$last_export_filepos."\r\n");
                            fseek($f_log,$last_export_filepos,0);
                            print("<pre>");
                            for ($l=0;$l<15;$l++) {
                                $st=fgets($f_log);
                				if (!strlen($st) && !feof($st)) {
                					$st=fgets($f_log);
                				}
                                //print("Len: ".strlen($st)."\r\n");
                                if (strlen($st)==254) {
                                    $st2=$st;
                                    while (strlen($st2)==254) {
                                        $st2=fgets($f_log);
                                        $st.=$st2;//$st2='';
                                    }
                                    //$st2=fgets($f_log);
                                    //$st.=$st2;$st2='';
                                }
                                if (!$st) {
                                    break;
                                }
                                //$a=explode($st,',');
                                $dt=intval(substr($st,0,strpos($st,',')));
                                $dt=intval(strftime("%Y",$dt));
                                print("Line: ".$st."\r\n");
                                //print($dt."\r\n");
                                //print_r($a);
                                if (is_ok($st) && ($dt >= 2015)) {
                            /*        for ($ch=0;$ch<strlen($st);$ch++) {
                                        if (charat())
                                    }*/
                                    print($dt." OK\r\n");
                                    $st.="\r\n";
                                    $export_size+=strlen($st);  // add cr+lf
                                    $csv_size+=strlen($st);
                                    $lines[$l]=$st;$st="";
                                } else {
                                    $l--;
                                    $csv_size+=strlen($st);
                                    log("[csv] Year=".$a." skipping CSV line ".$st);
                                }
                            }
                            print("<pre>Found ".($l-$mem_lines)." lines\r\n");
                            print("Export_file =".$last_export_file."\r\n");            
                            print("File_size =".filesize($logdir.$last_export_file)."\r\n");
                            print("Export_size =".$export_size."\r\n");
                            print("CSV _size =".$csv_size."\r\n");
                            print("CUR POSITION=".ftell($f_log)."\r\n");
                            $fp=ftell($f_log);
                            ini_set("/config/ftp_status.ini","status","filepos",$fp);
                            ini_set("/config/ftp_status.ini","status","file",$last_export_file);
                          //  print_r($lines);
                            fclose($f_log);
                            
                            $f=fopen('/logs/ftp_temp.csv','w');
                            $ini = ini_get_array("/config/dataexport.ini","export");

                            $num_groups = ini_get("/config/datalog.ini","data","num_groups",0);
                            $data='"ts",';
                            for ($i=0;$i<$num_groups;$i++) {
                                $s=ini_get("/config/datalog.ini","data",'group'+$i+'status',0);
                                
                                if ($s==1) {
                        
                                    $logfile2 = "/logs/log_"+$i+".ini";
                                    //$arr=ini_get_array($logfile2);
                                    
                                    $grpnvar=ini_get("/config/datalog.ini","data",'group'+$i+"numvar",0);
                                    for ($j=0;$j<$grpnvar;$j++) {
                                        $vt=ini_get("/config/datalog.ini","data",'group'+$i+'var'+$j+'vartype',0);
                                        $vfn=ini_get("/config/datalog.ini","data",'group'+$i+'var'+$j+'varfn',0);
                                        $vval=ini_get("/config/datalog.ini","data",'group'+$i+'var'+$j+'varval',0);
                                        if ($vt==1) {  // system
                                            $varst=ini_get("/config/sysvars.ini","sysvars","sysvar".$vval."name","");
                                            $varr=explode($varst,';');
                                            if ($varr[0]=='V') {
                                                $varst=$varr[1];
                                            } else {
                                                if ($varr[0]=='G') {
                                                    $varst=$varr[2].$varr[1];
                                                }
                                            }
                                        } else {
                                            if ($vt==2) {  // device
                                                $varst=ini_get("/config/roles.ini","roles","role".$vval,"");
                                            }
                                            if ($vt==3) {  // global
                                                //$varst=$vval;
                                                 $varst=ini_get("/config/datalog.ini","data",'group'+$i+'var'+$j+'varval','');
                                            }                
                                        }
                                        //$data.="\"".$varst."\":\"".$arr['data']['p'.$j]."\"";
                                        $data.='"'.$varst.'"';
                                        if ($j<($grpnvar-1)) $data.=",";
                                    }
                        
                                }
                            }
                            fwrite($f,$data);
                            fwrite($f,"\r\n");
                            for ($i=0;$i<sizeof($lines);$i++) {
                                fwrite($f,$lines[$i]);
                            }
                            fclose($f);
                            print('/logs/ftp_temp.csv created..size='.filesize('/logs/ftp_temp.csv').'\r\n');
                            
                        }   
                    }
                    $st=$prefix.substr($last_export_file,0,strlen($last_export_file)-4).time().".csv";
                    $res=ftp_upload($st,"/logs/ftp_temp.csv",0,1);
                    print ("upload result is ".$res);
                     
                      if ($res==1) {
                        log('deleting file as it was uploaded\r\n');       
                           unlink("/logs/ftp_temp.csv");
        
                      } else {  // deal with dongle reconnection issue
                            $stat=get3gstat(); 
                            if ($stat['enabled']) {
                                if ($stat['connected']) {
                                    if ($stat['ip_address']!='0.0.0.0') {
                                        $_GLOBALS['error3g']++;
                                        if ($_GLOBALS['error3g']>=5) {
                                            log("Cellular link seems to have died, restarting USB power");
                                            setusbpower(0);
                                            sleep(100);
                                            setusbpower(1);
                                            $_GLOBALS['error3g']=0;
                                        }
                                            
                                    }
                                }
                            }
                        }
    
            }
        }
    }

}
} else { // FTP Enabled
print("FTP Is disabled");
}
// end
?>






